package com.pixelized.server.lwa.server.rest.character

import com.pixelized.server.lwa.server.Engine
import com.pixelized.server.lwa.utils.extentions.characterSheetId
import com.pixelized.server.lwa.utils.extentions.exception
import com.pixelized.server.lwa.utils.extentions.param
import com.pixelized.shared.lwa.protocol.rest.APIResponse
import com.pixelized.shared.lwa.protocol.websocket.CharacterSheetEvent
import io.ktor.server.response.respond
import io.ktor.server.routing.RoutingContext

fun Engine.putCharacterDiminished(): suspend RoutingContext.() -> Unit {
    return {
        try {
            // get the query parameter
            val characterSheetId = call.queryParameters.characterSheetId
            val diminished: Int = call.queryParameters.param(
                name = "diminished",
                code = APIResponse.ErrorCode.Diminished,
            )
            // Update the character damage
            characterService.updateDiminished(
                characterSheetId = characterSheetId,
                diminished = diminished
            )
            // API & WebSocket responses.
            call.respond(
                message = APIResponse.success()
            )
            webSocket.emit(
                value = CharacterSheetEvent.UpdateDiminished(
                    timestamp = System.currentTimeMillis(),
                    characterSheetId = characterSheetId,
                    diminished = diminished,
                )
            )
        } catch (exception: Exception) {
            call.exception(
                exception = exception
            )
        }
    }
}